#ifndef FusionSubDataWrapper_WRAPPER_HEADER_H
#define FusionSubDataWrapper_WRAPPER_HEADER_H

#include "sub/SubDataWrapper.h"
#include "fusion/executable.h"

template <typename DataType>
class FrontCamDrvPerception2Fusion_SubDataWrapper : public SubDataWrapper<DataType>
{
	perception::vector_CameraPerception2Fusion _data;
    void Process(ara::com::SamplePtr<DataType const> *ptr) override
    {
        _data = *(perception::vector_CameraPerception2Fusion*)ptr->Get();
    }
public:
    perception::vector_CameraPerception2Fusion GetData()
    {
    	return _data;
    }
};
/*--------------------------------------------------------------------------------------------------*/
template <typename DataType>
class LeftCamDrvPerception2Fusion_SubDataWrapper : public SubDataWrapper<DataType>
{
	perception::vector_CameraPerception2Fusion _data;
    void Process(ara::com::SamplePtr<DataType const> *ptr) override
    {
    	_data = *(perception::vector_CameraPerception2Fusion*)ptr->Get();
    }
public:
    perception::vector_CameraPerception2Fusion GetData()
    {
    	return _data;
    }
};
/*--------------------------------------------------------------------------------------------------*/
template <typename DataType>
class RightCamDrvPerception2Fusion_SubDataWrapper : public SubDataWrapper<DataType>
{
	perception::vector_CameraPerception2Fusion _data;
    void Process(ara::com::SamplePtr<DataType const> *ptr) override
    {
    	_data = *(perception::vector_CameraPerception2Fusion*)ptr->Get();
    }
public:
    perception::vector_CameraPerception2Fusion GetData()
    {
    	return _data;
    }
};
/*--------------------------------------------------------------------------------------------------*/
template <typename DataType>
class RearCamDrvPerception2Fusion_SubDataWrapper : public SubDataWrapper<DataType>
{
	perception::vector_CameraPerception2Fusion _data;
    void Process(ara::com::SamplePtr<DataType const> *ptr) override
    {
    	_data = *(perception::vector_CameraPerception2Fusion*)ptr->Get();
    }
public:
    perception::vector_CameraPerception2Fusion GetData()
    {
    	return _data;
    }
};
/*--------------------------------------------------------------------------------------------------*/
template <typename DataType>
class CamPrkPerception2Fusion_SubDataWrapper : public SubDataWrapper<DataType>
{
	perception::vector_CameraPerception2Fusion _data;
    void Process(ara::com::SamplePtr<DataType const> *ptr) override
    {
    	_data = *(perception::vector_CameraPerception2Fusion*)ptr->Get();
    }
public:
    perception::vector_CameraPerception2Fusion GetData()
    {
    	return _data;
    }
};
/*--------------------------------------------------------------------------------------------------*/
template <typename DataType>
class VED2FusionEgoMotion_SubDataWrapper : public SubDataWrapper<DataType>
{
	dpc::VED4FusionEgoMotion _data;
    void Process(ara::com::SamplePtr<DataType const> *ptr) override
    {
    	_data = *ptr->Get();
    }
public:
    dpc::VED4FusionEgoMotion GetData()
    {
    	return _data;
    }
};
/*--------------------------------------------------------------------------------------------------*/
template <typename DataType>
class LidarPerception2Fusion_SubDataWrapper : public SubDataWrapper<DataType>
{
	perception::vector_LiDARPerception2Fusion _data;
    void Process(ara::com::SamplePtr<DataType const> *ptr) override
    {
    	_data = *(perception::vector_LiDARPerception2Fusion*)ptr->Get();
    }
public:
    perception::vector_LiDARPerception2Fusion GetData()
    {
    	return _data;
    }
};

#endif
